#include <stdio.h>
#include "boolean.h"

#ifndef FARMACO
#define FARMACO

#define FARMACO_NOME_DIM 51
#define PRINC_ATT_NOME_DIM 61
#define PRODUTTORE_NOME_DIM 51

typedef char NomeFarmaco[FARMACO_NOME_DIM];
typedef char NomePrincipioAttivo[PRINC_ATT_NOME_DIM];
typedef char Produttore[PRODUTTORE_NOME_DIM];

typedef struct PrincipioAttivoStruct
{
	NomePrincipioAttivo nome;
	int dosaggio;
} PrincipioAttivo;

typedef struct FarmacoStruct
{
	NomeFarmaco nome;
	Boolean originale;
	PrincipioAttivo principioAttivo;
	Produttore produttore;
	int giacenza;
} Farmaco;

#endif

//Crea una struttura Farmaco in memoria dinamica
Farmaco* createFarmaco();
void destroyFarmaco(Farmaco *f);

//Lettura/scrittura file/standard io
Farmaco* readFarmacoFromTxt(FILE *file);
void writeFarmacoToTxt(FILE *file, Farmaco *farmaco);
void printFarmaco(Farmaco *farmaco);

//Confronto per memorizzazione ordinata
int compareFarmaco(Farmaco *f1, Farmaco *f2);

//Confronto per nome parziale
Boolean farmacoNomeStartsWith(Farmaco *f1, NomeFarmaco nome);

//Confronto principi attivi (eventualmente ignorando il dosaggio)
int comparePrincipioAttivo(PrincipioAttivo p1, PrincipioAttivo p2, Boolean ignoreDosaggio);