#include <stdio.h>
#include "farmaco.h"

#ifndef FARMACO_LIST
#define FARMACO_LIST

typedef struct FarmacoListItemStruct
{
	Farmaco *farmaco;
	struct FarmacoListItemStruct *next;
} FarmacoListItem;

typedef FarmacoListItem *FarmacoList;

#endif

FarmacoListItem* createFarmacoListItem();
void destroyFarmacoListItem(FarmacoListItem *item, Boolean destroyPayload);

FarmacoList addToFarmacoList(FarmacoList list, Farmaco *f);
void destroyFarmacoList(FarmacoList list, Boolean destroyPayload);
FarmacoList findByPartialNome(FarmacoList list, NomeFarmaco nome);
FarmacoList findByPrincipioAttivo(FarmacoList list, PrincipioAttivo pAttivo, Boolean ignoreDosaggio);

FarmacoList readFarmacoListFromTxt(FILE *f);
void writeFarmacoListToTxt(FILE *f, FarmacoList list);
void printFarmacoList(FarmacoList list);