#include <stdio.h>
#include <string.h>
#include "boolean.h"
#include "farmaco.h"
#include "farmacoList.h"

FarmacoList createList()
{
	FarmacoList list = NULL;
	Farmaco *farmaco = NULL;

	farmaco = createFarmaco();
	strcpy(farmaco->nome, "Mesulid");
	farmaco->originale = true;
	strcpy(farmaco->principioAttivo.nome, "Nimesulide");
	farmaco->principioAttivo.dosaggio = 100;
	strcpy(farmaco->produttore, "Farmaceutici Damor S.p.A");
	farmaco->giacenza = 4;
	list = addToFarmacoList(list, farmaco);

	farmaco = createFarmaco();
	strcpy(farmaco->nome, "Aulin");
	farmaco->originale = true;
	strcpy(farmaco->principioAttivo.nome, "Nimesulide");
	farmaco->principioAttivo.dosaggio = 100;
	strcpy(farmaco->produttore, "Angelini");
	farmaco->giacenza = 3;
	list = addToFarmacoList(list, farmaco);

	farmaco = createFarmaco();
	strcpy(farmaco->nome, "Coxtral");
	farmaco->originale = false;
	strcpy(farmaco->principioAttivo.nome, "Nimesulide");
	farmaco->principioAttivo.dosaggio = 100;
	strcpy(farmaco->produttore, "Zentiva, s.a.");
	farmaco->giacenza = 10;
	list = addToFarmacoList(list, farmaco);

	farmaco = createFarmaco();
	strcpy(farmaco->nome, "Tachipirina");
	farmaco->originale = true;
	strcpy(farmaco->principioAttivo.nome, "Paracetamolo");
	farmaco->principioAttivo.dosaggio = 500;
	strcpy(farmaco->produttore, "Angelini");
	farmaco->giacenza = 7;
	list = addToFarmacoList(list, farmaco);

	farmaco = createFarmaco();
	strcpy(farmaco->nome, "Efferalgan");
	farmaco->originale = true;
	strcpy(farmaco->principioAttivo.nome, "Paracetamolo");
	farmaco->principioAttivo.dosaggio = 500;
	strcpy(farmaco->produttore, "Bristol-Meyers Squibb");
	farmaco->giacenza = 7;
	list = addToFarmacoList(list, farmaco);

	farmaco = createFarmaco();
	strcpy(farmaco->nome, "Acetamol");
	farmaco->originale = false;
	strcpy(farmaco->principioAttivo.nome, "Paracetamolo");
	farmaco->principioAttivo.dosaggio = 500;
	strcpy(farmaco->produttore, "Abiogen Pharma Spa");
	farmaco->giacenza = 2;
	list = addToFarmacoList(list, farmaco);

	farmaco = createFarmaco();
	strcpy(farmaco->nome, "Tachipirina 1000");
	farmaco->originale = true;
	strcpy(farmaco->principioAttivo.nome, "Paracetamolo");
	farmaco->principioAttivo.dosaggio = 1000;
	strcpy(farmaco->produttore, "Angelini");
	farmaco->giacenza = 1;
	list = addToFarmacoList(list, farmaco);

	farmaco = createFarmaco();
	strcpy(farmaco->nome, "Efferalgan 1000");
	farmaco->originale = true;
	strcpy(farmaco->principioAttivo.nome, "Paracetamolo");
	farmaco->principioAttivo.dosaggio = 1000;
	strcpy(farmaco->produttore, "Bristol-Meyers Squibb");
	farmaco->giacenza = 1;
	list = addToFarmacoList(list, farmaco);

	return list;
}

void saveToFile(char filename[], FarmacoList list)
{
	FILE *file;
	file = fopen(filename, "w");
	writeFarmacoListToTxt(file, list);
	fclose(file);
}

FarmacoList readFromFile(char filename[])
{
	FarmacoList list;
	FILE *file;
	file = fopen(filename, "r");
	list = readFarmacoListFromTxt(file);
	fclose(file);
	return list;
}

void createTestFile()
{
	FarmacoList list = createList();
	saveToFile("farmaci.txt", list);
	destroyFarmacoList(list, true);
}

int main()
{
	//createTestFile();

	PrincipioAttivo pa;
	FarmacoList list, sourceList = readFromFile("farmaci.txt");

	printf("Ricerca per nome parziale\n");
	list = findByPartialNome(sourceList, "tachi");
	writeFarmacoListToTxt(stdout, list);
	destroyFarmacoList(list, false);

	printf("\n\nRicerca per principio attivo senza dosaggio\n");
	strcpy(pa.nome, "Paracetamolo");
	pa.dosaggio = 0;
	list = findByPrincipioAttivo(sourceList, pa, true);
	writeFarmacoListToTxt(stdout, list);
	destroyFarmacoList(list, false);

	printf("\n\nRicerca per principio attivo con dosaggio\n");
	strcpy(pa.nome, "Paracetamolo");
	pa.dosaggio = 500;
	list = findByPrincipioAttivo(sourceList, pa, false);
	writeFarmacoListToTxt(stdout, list);
	destroyFarmacoList(list, false);


	destroyFarmacoList(sourceList, true);
}